package com.javacodegeeks.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.RootLayoutPanel;
import com.google.gwt.user.client.ui.SimpleLayoutPanel;
import com.google.gwt.user.client.ui.Widget;
import com.googlecode.gwt.charts.client.ChartLoader;
import com.googlecode.gwt.charts.client.ChartPackage;
import com.googlecode.gwt.charts.client.ColumnType;
import com.googlecode.gwt.charts.client.DataTable;
import com.googlecode.gwt.charts.client.corechart.PieChart;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class GWTChartExample implements EntryPoint {
	private SimpleLayoutPanel layoutPanel;
	private PieChart pieChart;

	/**
	 * This is the entry point method.
	 */
	@Override
	public void onModuleLoad() {
		Window.enableScrolling(false);
		Window.setMargin("0px");

		RootLayoutPanel.get().add(getSimpleLayoutPanel());

		// Create the API Loader
		ChartLoader chartLoader = new ChartLoader(ChartPackage.CORECHART);
		chartLoader.loadApi(new Runnable() {

			@Override
			public void run() {
				getSimpleLayoutPanel().setWidget(getPieChart());
				drawPieChart();
			}
		});
	}

	private SimpleLayoutPanel getSimpleLayoutPanel() {
		if (layoutPanel == null) {
			layoutPanel = new SimpleLayoutPanel();
		}
		return layoutPanel;
	}

	private Widget getPieChart() {
		if (pieChart == null) {
			pieChart = new PieChart();
		}
		return pieChart;
	}

	private void drawPieChart() {
		// Prepare the data
		DataTable dataTable = DataTable.create();
		dataTable.addColumn(ColumnType.STRING, "Subject");
		dataTable.addColumn(ColumnType.NUMBER, "Number of students");
		dataTable.addRows(4);
		dataTable.setValue(0, 0, "History");
		dataTable.setValue(1, 0, "Computers");
		dataTable.setValue(2, 0, "Management");
		dataTable.setValue(3, 0, "Politics");
		dataTable.setValue(0, 1, 20);
		dataTable.setValue(1, 1, 25);
		dataTable.setValue(2, 1, 30);
		dataTable.setValue(3, 1, 35);

		// Draw the chart
		pieChart.draw(dataTable);
	}
}
